; OpenMouse() : void
; CloseMouse() : void
;
PUBLIC OpenMouse
PUBLIC CloseMouse
;
INCLUDE EXTENDA.MAC
;
kbd_tail	equ	1Ch  
kbd_head	equ	1Ah
bufer_start	equ	80h
bufer_end	equ	82h
left		equ	4Bh
right		equ	4Dh
up		equ	48h
down		equ	50h
enter_key	equ	1C0Dh
esc_key		equ	011Bh
f10_key		equ	4400h
  
_PROG		segment	'CODE'		; Start of code segment.
ASSUME		cs:_PROG,ds:_PROG

handler		proc	far
		push	ax bx cx dx si di es ds
		push	cs
		pop	ds
		test	al,2
		jnz	left_pressed
		test	al,8
		jnz	right_pressed
		test	al,20h
		jnz	center_pressed

		mov	ax,0Bh			; last motion
		int	33h
		add	cx,ddx
		mov	ax,cx
		and	ax,7
		mov	ddx,ax			; rest x

		add	dx,ddy
		mov	ax,dx
		and	ax,7
		mov	ddy,ax			; rest y

		sar	cx,1
		sar	cx,1
		sar	cx,1

		sar	dx,1
		sar	dx,1
		sar	dx,1
@@loop:
		mov	ax,cx
		or	ax,dx
		jz	@@exit

		xor	ax,ax
		cmp	cx,ax
		jz	@@skip_x
		jg	@@ung_r

		mov	ah,left
		call	unget_char
		inc	cx
		jmp	@@skip_x

@@ung_r:
		mov	ah,right
		call	unget_char
		dec	cx
@@skip_x:
		cmp	dx,0
		jz	@@loop
		jg	@@ung_d
		mov	ah,up
		call	unget_char
		inc	dx
		jmp	@@loop
@@ung_d:
		mov	ah,down
		call	unget_char
		dec	dx
		jmp	@@loop

left_pressed:
		mov	ax,enter_key
		call	unget_char
		jmp	@@exit
right_pressed:
		mov	ax,esc_key
		call	unget_char
		jmp	@@exit
center_pressed:
		mov	ax,f10_key
		call	unget_char
@@exit:
		pop	ds es di si dx cx bx ax
		retf

handler		endp

ddx		dw	0
ddy		dw	0

unget_char	proc	near
		mov	bx,40h
		mov	ds,bx
		mov	bx,ds:kbd_tail
		mov	si,bx
		add	si,2
		cmp	si,ds:bufer_end
		jne	@@lab
		mov	si,ds:bufer_start
@@lab:
		cmp	si,kbd_head
		je	@@done
		mov	[bx],ax
		mov	ds:kbd_tail,si
@@done:		retn
unget_char	endp

old_int33	dd	0
old_cx		dw	0

OpenMouse	PROC	FAR
		PushStack	<DS,ES,DI,SI>
		mov	ax,0
		int	33h
		or	ax,ax			; mouse installed ?
		jz	@@not_inst
		push	cs
		pop	ds
		push	cs
		pop	es
		mov	ax,0014h
		mov	cx,002Bh
		mov	dx,offset handler
		int	33h
		mov	word ptr old_int33,dx
		mov	word ptr old_int33+2,es
		mov	old_cx,cx
@@not_inst:
		PopStack	<SI,DI,ES,DS>
	        RET_VOID
	        ret
OpenMouse	ENDP
;
CloseMouse	PROC	FAR
		PushStack	<DS,ES,DI,SI>
		mov	ax,0
		int	33h
		or	ax,ax			; mouse installed ?
		jz	@@not_inst1
		push	cs
		pop	ds
		mov	ax,0014h
		mov	cx,old_cx
		mov	dx,word ptr old_int33
		mov	es,word ptr old_int33+2
		int	33h
@@not_inst1:
		PopStack	<SI,DI,ES,DS>
	        RET_VOID
	        ret
CloseMouse	ENDP
;
_PROG		ENDS
		END
